package com.flossom.system.service;


import com.flossom.common.core.domain.entity.WxUserMember;
import com.flossom.common.core.domain.req.WxUserIntegralVm;
import com.flossom.common.core.domain.req.WxUserMemberReq;
import com.flossom.common.core.domain.req.WxUserMemberVm;
import com.flossom.common.core.domain.ret.WxUserMemberRet;
import com.flossom.common.core.domain.vo.WxUserMemberVo;

import java.util.List;

/**
 * 用户Service接口
 *
 * @author flossom
 * @date 2023-12-08
 */
public interface



IWxUserMemberService
{
    /**
     * 查询用户
     *
     * @param id 用户主键
     * @return 用户
     */
    public WxUserMemberVo selectWxUserMemberById(Long id);

    /**
     * 查询用户
     *
     * @param id 用户主键原始方法
     * @return 用户
     */
    public WxUserMember selectWxUserMemberByIdInit(Long id);


    /**
     * 查询用户列表
     *
     * @param wxUserMember 用户
     * @return 用户集合
     */
    public List<WxUserMember> selectWxUserMemberList(WxUserMember wxUserMember);

    /**
     * 查询用户列表
     *
     * @param wxUserMemberVm 用户
     * @return 用户集合
     */
    public List<WxUserMember> selectWxUserMemberList(WxUserMemberVm wxUserMemberVm);

    /**
     * 新增用户
     *
     * @param wxUserMember 用户
     * @return 结果
     */
    public int insertWxUserMember(WxUserMember wxUserMember);

    /**
     * 修改用户
     *
     * @param wxUserMember 用户
     * @return 结果
     */
    public int updateWxUserMember(WxUserMemberReq wxUserMember);

    /**
     * 批量删除用户
     *
     * @param ids 需要删除的用户主键集合
     * @return 结果
     */
    public int deleteWxUserMemberByIds(Long[] ids);

    /**
     * 删除用户信息
     *
     * @param id 用户主键
     * @return 结果
     */
    public int deleteWxUserMemberById(Long id);

    List<Integer> selectUserCount();

    public void batchAddWecomTag(List<Integer> tagIdList, List<Integer> userIdList);

    void batchAddMiniProgramTag(List<Integer> tagId, List<Integer> userIds);

    void batchDelMiniProgramTag(List<Integer> tagIdList, List<Integer> userIdList);

    void batchChangIntegral(WxUserIntegralVm wxUserIntegralVm, List<Long> userIdList);

    void openOrCloseClock(Long id);

    void openOrCloseActivity(Long id);

    List<WxUserMemberRet> selectWxUserMemberRetList(WxUserMemberVm wxUserMemberVm);

    List<WxUserMemberRet> selectWxUserMemberByIdList(List<Integer> userIdList);
}
